## mingw-w64-frontistr-5.6-3.src.tar.zst

=== CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

###############################################################
# CMakeLists.txt for FrontISTR
###############################################################
cmake_minimum_required(VERSION 2.8.11)

###############################################################
# Check building mode whether out-of-source builds
###############################################################
if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
  message(FATAL_ERROR "
*************** ERROR ***************
 Only support for out-of-source building.
 You may need to remove CMakeCache.txt file and CMakeFiles/ directory.
 Please make new directory such as build/ and run cmake in it again.
[example]
 rm CMakeCache.txt; rm -rf CMakeFiles/
 mkdir build/; cd build/
 cmake ..
 make")
endif()

project(FrontISTR Fortran C CXX)
###############################################################
# Includes standard macros
###############################################################
include(FeatureSummary)
include(CMakeDependentOption)
include(CMakeDetermineFortranCompiler)

###############################################################
# Add module path for FindPackage.cmake
###############################################################
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

###############################################################
# Initialize variable of definitions, link libraries, includes
###############################################################
set(FrontISTR_DEFINITIONS)
set(FrontISTR_LIBRARIES)
set(FrontISTR_INCLUDE_DIRS ${CMAKE_Fortran_MODULE_DIRECTORY} ${PROJECT_BINARY_DIR})

###############################################################
# Build type (RELEASE or DEBUG)
###############################################################
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RELEASE" CACHE STRING "Build type (RELEASE or DEBUG)" FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS RELEASE DEBUG)
endif()
if(CMAKE_BUILD_TYPE MATCHES "DEBUG")
  list(APPEND FrontISTR_DEFINITIONS "DEBUG")
  # Enable debug options
  find_package(Backtrace)
  if(Backtrace_FOUND)
    list(APPEND FrontISTR_LIBRARIES ${Backtrace_LIBRARY})
    list(APPEND FrontISTR_INCLUDE_DIR ${Backtrace_INCLUDE_DIR})
    set(CMAKE_VERBOSE_MAKEFILE ON)
    # GNU Compiler
    if(CMAKE_C_COMPILER_ID MATCHES "GNU")
      set(CMAKE_C_FLAGS_DEBUG
        "${CMAKE_C_FLAGS_DEBUG} -Wall -Wextra")
      set(CMAKE_CXX_FLAGS_DEBUG
        "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wextra")
      set(CMAKE_Fortran_FLAGS_DEBUG
        "${CMAKE_Fortran_FLAGS_DEBUG} -Wall -Wextra -fbounds-check -fbacktrace")
      if(${DEBUG_EXTRA})
        set(CMAKE_C_FLAGS_DEBUG
          "${CMAKE_C_FLAGS_DEBUG} -fsanitize=address")
        set(CMAKE_CXX_FLAGS_DEBUG
          "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=address")
        set(CMAKE_Fortran_FLAGS_DEBUG
          "${CMAKE_Fortran_FLAGS_DEBUG} -fsanitize=address")
      endif()
    # Intel Compiler
    elseif(CMAKE_C_COMPILER_ID MATCHES "Intel")
      set(CMAKE_C_FLAGS_DEBUG
        "${CMAKE_C_FLAGS_DEBUG} -Wall -Wbrief -Wcheck")
      set(CMAKE_CXX_FLAGS_DEBUG
        "${CMAKE_CXX_FLAGS_DEBUG} -Wall -Wbrief -Wcheck")
      set(CMAKE_Fortran_FLAGS_DEBUG
        #"${CMAKE_Fortran_FLAGS_DEBUG} -warn all -check all -traceback")
        "${CMAKE_Fortran_FLAGS_DEBUG} -warn nounused -check uninit,bound -traceback")
    endif()
  endif()
elseif (CMAKE_BUILD_TYPE MATCHES "RELEASE")
  list(APPEND FrontISTR_DEFINITIONS "NDEBUG")
endif()

###############################################################
# Version number
###############################################################
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

file(READ "VERSION" ver)
string(REGEX MATCH "[0-9](.[0-9](.[0-9])?)?" vertxt ${ver})
string(REGEX MATCHALL "[0-9]" verlist "${vertxt}")
list(LENGTH verlist verlength)
set(VERSION_MAJOR 0)
set(VERSION_MINOR 0)
set(VERSION_PATCH 0)
list(GET verlist 0 VERSION_MAJOR)
if(${verlength} GREATER 1)
  list(GET verlist 1 VERSION_MINOR)
endif()
if(${verlength} GREATER 2)
  list(GET verlist 2 VERSION_PATCH)
endif()
execute_process(COMMAND date "+%Y-%m-%dT%H:%M:%S%z" OUTPUT_VARIABLE BUILD_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
set(GIT_HASH \"${GIT_SHA1}\" CACHE STRING "GIT hash number of FrontISTR")
mark_as_advanced(VERSION_MAJOR VERSION_MINOR VERSION_PATCH BUILD_DATE GIT_HASH)

#############################################
# Architecture and compiler dependent options
#############################################
if(WIN32)
  set(WINDOWS TRUE)
endif()

###############################################################
# Options
###############################################################
# -DWINDOWS          : build on Windows
# -DWITH_TOOLS       : compile tools
# -DWITH_MPI         : for parallel environment with MPI
# -DWITH_OPENMP      : for multi-(core|processor) environment
# -DWITH_REFINER     : compile with REVOCAP_Refiner
# -DWITH_REVOCAP     : compile with REVOCAP_Coupler
# -DWITH_METIS       : compile with METIS graph partitioning package
#   -DMETIS_VER_4    : uses METIS-4
# -DWITH_PARMETIS    : compile with ParMETIS
#   -DPARMETIS_VER_3 : uses PARMETIS-3
# -DWITH_MKL         : compile with MKL PARDISO
# -DWITH_MUMPS       : compile with MUMPS direct solver
# -DWITH_LAPACK      : compile with LAPACK
# -DWITH_ML          : compile with Trilinos multigrid preconditioning package
# -DWITH_DOC         : generate API documents
# -DOLD_RES_FORMAT   : use old style result file( comment and global output disabled)

###################
# Find external packages
###################
option(WITH_MPI "for parallel environment with MPI" ON)
if(WITH_MPI)
  find_package(MPI)
  set(WITH_MPI "${MPI_FOUND}")
  find_package(Parmetis)
  find_package(Scalapack)
endif()
find_package(OpenMP)
find_package(MKL)
find_package(LAPACK)
find_package(Metis)
find_package(Mumps)
find_package(Refiner)
find_package(Revocap)
find_package(Trilinos)
find_package(Doxygen)
option(WITH_TOOLS "compile tools" ON)
option(WITH_DOC "Generate API documents." ${WITH_DOC})
option(WINDOWS "build on windows" ${WINDOWS})
option(WITH_OPENMP "for multi-(core|processor) environment" ${OPENMP_FOUND})
option(WITH_MKL "compile with MKL PARDISO" ${MKL_FOUND})
option(WITH_LAPACK "for estimating number of condition" ${LAPACK_FOUND})
option(WITH_METIS "compile with METIS" ${METIS_FOUND})
option(METIS_VER_4 "uses METIS-4" OFF)
option(WITH_MUMPS "compile with MUMPS direct solver" ${MUMPS_FOUND})
option(WITH_PARMETIS "compile with ParMETIS" ${PARMETIS_FOUND})
option(PARMETIS_VER_3 "uses METIS-3" OFF)
option(WITH_REFINER "compile with REVOCAP_Refiner" ${REFINER_FOUND})
option(WITH_REVOCAP "compile with REVOCAP_Coupler" ${REVOCAP_FOUND})
option(WITH_ML "compile with Trilinos ML" ${Trilinos_FOUND})
option(OLD_RES_FORMAT "use old style result file" ${OLD_RES_FORMAT})
option(DEBUG_EXTRA "enable memory leak check (only for gcc4.9 <)" OFF)
feature_summary(WHAT ALL)

# Provisional solution FOR GCC Fortran 10 compiling error
if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 10)
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
endif()

###################
# -DWITH_OPENMP
###################
if(WITH_OPENMP AND OPENMP_FOUND)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_Fortran_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
else()
  set(WITH_OPENMP OFF)
endif()

###################
# -DWITH_MKL
###################
if(WITH_MKL)
  set(BLA_VENDOR "Intel10_64lp")
  list(APPEND FrontISTR_INCLUDE_DIRS ${MKL_INCLUDE_PATH})
  list(APPEND FrontISTR_LIBRARIES ${MKL_LIBRARIES})
  list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_MKL")
  set(WITH_LAPACK ON)
else()
  set(WITH_MKL OFF)
endif()

###################
# -DWITH_REFINER
###################
if(WITH_REFINER AND REFINER_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${REFINER_INCLUDE_PATH})
  list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_REFINER")
  list(APPEND FrontISTR_LIBRARIES ${REFINER_LIBRARIES})
else()
  set(WITH_REFINER OFF)
  set(HECMW_WITH_REFINER OFF)
endif()

###################
# -DWITH_REVOCAP
###################
if(WITH_REVOCAP AND REVOCAP_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${REVOCAP_INCLUDE_PATH})
else()
  set(WITH_REVOCAP OFF)
endif()

###################
# -DWITH_ML
###################
if(WITH_ML)
  if(Trilinos_FOUND)
    list(FIND Trilinos_TPL_LIST MPI trilinos_mpi_index)
    if((trilinos_mpi_index EQUAL -1 AND WITH_MPI) OR (trilinos_mpi_index GREATER -1 AND NOT WITH_MPI))
      message(WARNING "Trilinos found but turned off due to incompatible MPI setting")
      set(WITH_ML OFF)
    else()
      list(APPEND FrontISTR_INCLUDE_DIRS ${Trilinos_INCLUDE_DIRS} ${Trilinos_TPL_INCLUDE_DIRS})
      list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_ML")
      list(APPEND FrontISTR_LIBRARIES ${Trilinos_LIBRARIES} ${Trilinos_TPL_LIBRARIES})
    endif()
  else()
    message(WARNING "Trilinos not found")
    set(WITH_ML OFF)
  endif()
endif()
mark_as_advanced(Trilinos_DIR)

###################
# -DWITH_MUMPS
###################
if(WITH_MUMPS)
  if(MUMPS_FOUND)
    if(WITH_MPI)
      if((SCALAPACK_FOUND AND LAPACK_FOUND) OR SCALAPACK_MKL)
        list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_MUMPS")
        list(APPEND FrontISTR_INCLUDE_DIRS ${MUMPS_INCLUDE_PATH})
        list(APPEND FrontISTR_LIBRARIES ${MUMPS_LIBRARIES} ${SCALAPACK_LIBRARIES})
        mark_as_advanced(scalapack_DIR)
      else()
        message(WARNING "MUMPS could not be enabled. Please also install scalapack and lapack.")
        set(WITH_MUMPS OFF)
      endif()
    else()
      list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_MUMPS")
      list(APPEND FrontISTR_INCLUDE_DIRS ${MUMPS_INCLUDE_PATH})
      list(APPEND FrontISTR_LIBRARIES ${MUMPS_LIBRARIES})
    endif()
  else()
    message(WARNING "MUMPS not found")
    set(WITH_MUMPS OFF)
  endif()
endif()

###################
# -DWITH_PARMETIS
###################
if(WITH_PARMETIS AND PARMETIS_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${PARMETIS_INCLUDE_PATH})
  list(APPEND FrontISTR_LIBRARIES ${PARMETIS_LIBRARIES})
  if(NOT PARMETIS_VER_3)
  else()
  endif()
endif()

###################
# -DWITH_METIS
# -DMETIS_VER_4
###################
if(WITH_METIS AND METIS_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS ${METIS_INCLUDE_PATH})
  list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_METIS")
  list(APPEND FrontISTR_DEFINITIONS "HECMW_PART_WITH_METIS")
  list(APPEND FrontISTR_LIBRARIES ${METIS_LIBRARIES})
  if(NOT METIS_VER_4)
    list(APPEND FrontISTR_DEFINITIONS "HECMW_METIS_VER=5")
  else()
    list(APPEND FrontISTR_DEFINITIONS "HECMW_METIS_VER=4")
  endif()
endif()

###################
# -DWITH_LAPACK
###################
if(WITH_LAPACK)
  if(LAPACK_FOUND AND BLAS_FOUND)
    list(APPEND FrontISTR_DEFINITIONS "HECMW_WITH_LAPACK")
    list(APPEND FrontISTR_LIBRARIES ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
  else()
    set(WITH_LAPACK OFF)
  endif()
endif()


###################
# -DOLD_RES_FORMAT
###################
if(OLD_RES_FORMAT)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DOLD_RES_FORMAT")
endif()

###################
# -DWITH_MPI
###################
if(WITH_MPI AND MPI_Fortran_FOUND AND MPI_CXX_FOUND AND MPI_C_FOUND)
  list(APPEND FrontISTR_INCLUDE_DIRS
    ${MPI_C_INCLUDE_PATH}
    ${MPI_CXX_INCLUDE_PATH}
    ${MPI_Fortran_INCLUDE_PATH})

  list(APPEND FrontISTR_LIBRARIES
    ${MPI_C_LIBRARIES}
    ${MPI_CXX_LIBRARIES}
    ${MPI_Fortran_LIBRARIES})

else()
  set(WITH_MPI OFF)
  set(HECMW_SERIAL ON)

=== fistr1/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

project(fistr CXX Fortran C)

set(fistr_SOURCES)
set(fistr_INCLUDE_DIRS)
set(fistr_DEFINITIONS)
set(fistr_LIBRARIES)
set(fistr1_SOURCES)

#
# Inherit definitions from fistr options
#
set(fistr_INCLUDE_DIRS ${FrontISTR_INCLUDE_DIRS} ${CMAKE_BINARY_DIR}/hecmw1)
set(fistr_DEFINITIONS ${FrontISTR_DEFINITIONS})
set(fistr_LIBRARIES ${FrontISTR_LIBRARIES})

#
# Build for libfistr.a
#
include(src/CMakeLists.txt)
add_library(fistr STATIC ${fistr_SOURCES})
target_link_libraries(fistr hecmw)
target_include_directories(fistr PUBLIC
  ${fistr_INCLUDE_DIRS} ${hecmw_INCLUDE_DIRS}
)
target_compile_definitions(fistr PUBLIC
  ${fistr_DEFINITIONS} ${hecmw_DEFINITIONS}
)

#
# Build for fistr1 (executable)
#
include(src/main/CMakeLists.txt)
add_executable(fistr1 ${fistr1_SOURCES})
target_link_libraries(fistr1
  fistr hecmw ${hecmw_LIBRARIES} ${fistr_LIBRARIES}
  ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES}
)

set_target_properties(fistr1 PROPERTIES LINKER_LANGUAGE "CXX")

target_include_directories(fistr1 PUBLIC
  ${fistr_INCLUDE_DIRS}
  ${hecmw_INCLUDE_DIRS}
  ${CMAKE_Fortran_MODULE_DIRECTORY}
)
target_compile_definitions(fistr1 PUBLIC
  ${fistr_DEFINITIONS}
  ${hecmw_DEFINITIONS}
)

#
# Set installing files
#
install(TARGETS fistr1
  DESTINATION bin
  CONFIGURATIONS ${CMAKE_BUILD_TYPE}
)

#
# Build tools
#
if(WITH_TOOLS)
  add_subdirectory(tools)
endif()

=== docker/container/Makefile ===
CI_REGISTRY_IMAGE  ?= registry.gitlab.com/frontistr-commons/frontistr
ARCH  ?= x86_64

ifdef CI_COMMIT_TAG
  TAG ?= $(CI_COMMIT_TAG)
else
  ifdef CI_COMMIT_REF_SLUG
    TAG ?= $(CI_COMMIT_REF_SLUG)
    TAG := $(shell echo $(TAG) | sed -e 's/\//__/')
  else
    TAG := _no_branch
  endif
endif

all: push

login:
ifeq ($(CI_JOB_TOKEN),)
	docker login $(CI_REGISTRY_IMAGE)
else
	docker login -u gitlab-ci-token -p $(CI_JOB_TOKEN) $(CI_REGISTRY_IMAGE)
endif

push: login
	-docker buildx create --name multiarch --driver docker-container
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/fistr1:$(TAG) -f Dockerfile     --target fistr1 ../..
ifeq ($(TAG),master)
	docker buildx build --push --builder multiarch --platform $(ARCH) -t $(CI_REGISTRY_IMAGE)/fistr1:latest -f Dockerfile     --target fistr1 ../..
endif

=== hecmw1/src/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

include(${CMAKE_CURRENT_LIST_DIR}/common/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/solver/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/hecmw/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/visualizer/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/operations/element_smoothing/CMakeLists.txt)

=== fistr1/tools/neu2fstr/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

include(${CMAKE_CURRENT_LIST_DIR}/HECD/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/NFD/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/converter/CMakeLists.txt)

list(APPEND neu2fstr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/neu2fstr.cpp
)

=== hecmw1/src/couple/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_comm.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_copy_c2f.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_copy_f2c.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_control.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_info.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_info_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_get_mesh.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_boundary_info.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_bounding_box.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_background_cell.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_mapped_point.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_judge.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_inter_iftable.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_intra_iftable.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_weight.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_s2n_average.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_s2n_with_area.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_s2n_dist_node.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_s2n_dist_surf.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_n2s_average.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_n2s_with_area.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_interpolate_info.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_init.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_startup.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_finalize.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_init_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_startup_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_finalize_if.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_define_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_struct_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_copy_c2f_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_copy_f2c_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_info_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_get_mesh_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_init_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_startup_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_cleanup_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_f.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_couple_finalize_f.f90
)

list(APPEND hecmw_INCLUDE_DIRS
  ${CMAKE_CURRENT_LIST_DIR}
)

=== hecmw1/src/solver/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

include(${CMAKE_CURRENT_LIST_DIR}/communication/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/las/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/matrix/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/init/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/sparse_matrix/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/mumps/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/mkl/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/clustermkl/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/precond/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/iterative/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/solver_direct/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/solver_direct_parallel/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/solver_direct_lag/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/contact/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/mpc/CMakeLists.txt)
include(${CMAKE_CURRENT_LIST_DIR}/main/CMakeLists.txt)

=== hecmw1/tools/partitioner/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_part1_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_partlex.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_part_log.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_mesh_hash_sort.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_mesh_edge_info.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_part_get_control.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_init_for_partition.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_graph.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_partition.c
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_partitioner.c
)

=== fistr1/src/lib/user/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/uelastic.f90
  ${CMAKE_CURRENT_LIST_DIR}/uhardening.f90
  ${CMAKE_CURRENT_LIST_DIR}/uload.f90
  ${CMAKE_CURRENT_LIST_DIR}/umat.f90
  ${CMAKE_CURRENT_LIST_DIR}/uyield.f90
)

=== hecmw1/src/solver/clustermkl/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_ClusterMKL_wrapper.F90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_solver_direct_ClusterMKL.f90
)

=== hecmw1/src/solver/contact/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_mat_resid_contact.f90
  ${CMAKE_CURRENT_LIST_DIR}/sparse_matrix_contact.f90
  ${CMAKE_CURRENT_LIST_DIR}/solve_LINEQ_MUMPS_contact.f90
  ${CMAKE_CURRENT_LIST_DIR}/set_arrays_DirectSolver.f90
  ${CMAKE_CURRENT_LIST_DIR}/solve_LINEQ_mkl.F90
  ${CMAKE_CURRENT_LIST_DIR}/solve_LINEQ_direct_serial_lag.f90
  ${CMAKE_CURRENT_LIST_DIR}/solve_LINEQ_contact_elim.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_solver_contact.f90
)

=== hecmw1/src/solver/init/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND hecmw_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_solve_init.f90
  ${CMAKE_CURRENT_LIST_DIR}/hecmw_solve_error.f90
)

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=frontistr
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.6
pkgrel=3
pkgdesc='Open-Source Large-Scale Parallel FEM Program for Nonlinear Structural Analysis (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.frontistr.com"
msys2_repository_url="https://github.com/frontistr/frontistr"
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-metis"
         # "${MINGW_PACKAGE_PREFIX}-mumps" Couldn't be found by cmake!
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openblas")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             $([[ ${CARCH} == aarch64 ]] || echo \
               "${MINGW_PACKAGE_PREFIX}-msmpi" \
               "${MINGW_PACKAGE_PREFIX}-parmetis" \
               "${MINGW_PACKAGE_PREFIX}-scalapack" \
               "${MINGW_PACKAGE_PREFIX}-trilinos")
             "${MINGW_PACKAGE_PREFIX}-seacas")
source=("https://github.com/${_realname}/${_realname}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-fix-build-with-flang.patch")
sha256sums=('e818698f61c4482151e7aa9d27cabfa14c8c1643a99511ec45659b883e78c742'
            'd13265d210a5263485f6100334a9faa95139c120a16ef4202cc65d2e0ffe23b4')

prepare() {
  cd ${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-build-with-flang.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} != aarch64 ]]; then
    _extra_config+=("-DWITH_MPI=ON" "-DWITH_ML=ON")
  else
    _extra_config+=("-DWITH_MPI=OFF" "-DWITH_ML=OFF")
    CFLAGS+=" -Wno-implicit-function-declaration"
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    export FFLAGS="-fallow-invalid-boz"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${_extra_config[@]}" \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
  
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR=${pkgdir} cmake --install .

  install -Dm644 ${srcdir}/${_realname}-${pkgver}/License.txt \
    ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE 

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in $(find "${pkgdir}${MINGW_PREFIX}"/lib/cmake -type f); do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done
  
}
